Imports System.Math

''' <summary>
''' Really simplistic, yet effective, steering actor that works
''' fine for most skid-steered and differential drive robots.
''' </summary>
''' <remarks></remarks>
Public Class StandardDriveActor
    Inherits DriveActor


    Private _HeadLight As Boolean = False
    Private _Forward As Single = 0
    Private _TurnLeft As Single = 0
    Private _CameraTilt As Single = 0


    Public Overrides Sub Drive(ByVal speed As Single)
        Me._Forward = speed
        Me._TurnLeft = 0
        Me.Move(Me._Forward, Me._TurnLeft, Me._HeadLight)
    End Sub

    Public Overrides Sub Turn(ByVal left As Single)
        Me._Forward = 0
        Me._TurnLeft = left
        Me.Move(Me._Forward, Me._TurnLeft, Me._HeadLight)
    End Sub


    Public Overrides Sub ToggleHeadLight()
        Me._HeadLight = Not Me._HeadLight
        Me.Move(Me._Forward, Me._TurnLeft, Me._HeadLight)
    End Sub

    Public Overrides Sub CameraPanTilt(ByVal up As Single)
        Me._CameraTilt = up
        Me.SendUsarSimCommand(String.Format("MISPKG {{Name CameraPanTilt}} {{Link 1}} {{Value {0}}} {{Link 2}} {{Value {1}}}", _
                 0, _
                 up))
    End Sub

    Protected Sub Move(ByVal forward As Single, ByVal left As Single, ByVal headLight As Boolean)
        Me.SendUsarSimCommand(String.Format("DRIVE {{Left {0}}} {{Right {1}}} {{Light {2}}}", _
         forward - left, _
         forward + left, _
         headLight.ToString))
    End Sub

End Class
