Public MustInherit Class Behavior

    Public Sub New(ByVal control As BehaviorControl)
        Me._Active = False
        Me._Control = control
    End Sub

    Private _Active As Boolean
    Public ReadOnly Property Active() As Boolean
        Get
            Return Me._Active
        End Get
    End Property

    Private _Control As BehaviorControl
    Public ReadOnly Property Control() As BehaviorControl
        Get
            Return Me._Control
        End Get
    End Property


    Public Sub Activate()
        If Not Me._Active Then
            Me._Active = True
            Me.OnActivated()
        End If
    End Sub
    Public Sub DeActivate()
        If Me._Active Then
            Me._Active = False
            Me.OnDeActivated()
        End If
    End Sub


    Protected Overridable Sub OnActivated()
    End Sub
    Protected Overridable Sub OnDeActivated()
    End Sub


    Public Sub NotifySensorUpdate(ByVal sensor As Sensor)
        Me.OnNotifySensorUpdate(sensor)
    End Sub

    Protected Overridable Sub OnNotifySensorUpdate(ByVal sensor As Sensor)
    End Sub

End Class
