''' <summary>
''' A single-state sensor only hold the last (i.e. current) sensor reading.
''' </summary>
''' <typeparam name="TData"></typeparam>
''' <remarks></remarks>
Public Class SingleStateSensor(Of TData As ISensorData)
    Inherits Sensor

    Protected Sub New(ByVal data As TData, ByVal type As String, ByVal name As String)
        MyBase.New(type, name)
        Me._data = data
    End Sub

    Private _data As TData
    Public ReadOnly Property CurrentData() As TData
        Get
            Return _data
        End Get
    End Property

    ''' <summary>
    ''' Updates the current data with the data from the msg. 
    ''' </summary>
    ''' <param name="msg"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)
        Me.CurrentData.Load(msg)
    End Sub

End Class
