Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports System.Text


Public Class CameraSensor
    Inherits MultiStateSensor(Of CameraData)

    Public Shared ReadOnly SENSORTYPE_CAMERA As String = "Camera"

#Region " Constructor "

    Public Sub New()
        MyBase.New(SENSORTYPE_CAMERA, Sensor.MATCH_ANYNAME, 100)
        Me._sequence = 0
    End Sub

    Public Sub New(ByVal agentConfig As AgentConfig)
        Me.New()
        With agentConfig
            Me._spawnNumber = .AgentNumber
            If String.Equals(.MultiViewPanels, "") Then
                Me._multiviewMode = 0
            Else
                Me._multiviewMode = CByte(.MultiViewPanels)
            End If
        End With
    End Sub

#End Region

#Region " Properties "

    Dim _sequence As Integer
    Public ReadOnly Property Sequence() As Integer
        Get
            Return _sequence
        End Get
    End Property

    Private Function NextSequence() As Integer
        If Me._sequence < Integer.MaxValue Then
            Me._sequence += 1
        Else
            Me._sequence = 0
        End If
        Return _sequence
    End Function

    Dim _spawnNumber As Integer
    Public ReadOnly Property SpawnNumber() As Integer
        Get
            Return _spawnNumber
        End Get
    End Property

    Dim _multiviewMode As Byte
    Public ReadOnly Property MultiviewMode() As Byte
        Get
            Return Me._multiviewMode
        End Get
    End Property

    Private _latestCamIm As Drawing.Bitmap
    Public Property LatestCamIm() As Drawing.Bitmap
        Get
            Return Me._latestCamIm
        End Get
        Set(ByVal value As Drawing.Bitmap)
            Me._latestCamIm = value
        End Set
    End Property

#End Region

#Region "ProcessImage"
    Protected Overrides Sub ProcessBytes(ByVal bytes() As Byte)
        Dim data As New CameraData
        data.Load(bytes, Me.SpawnNumber, Me.MultiviewMode, Me.NextSequence)
        Me.LatestCamIm = data.Bitmap
        Me.EnqueueData(data)
        Me.Agent.NotifySensorUpdate(Me)
    End Sub

#End Region

End Class
