'SEN {Type Odometry} {Name string} {Pose x,y,theta}

<Serializable()> _
Public Class OdometryData
	Implements ISensorData

    Private _OffsetX As Double
    Private _OffsetY As Double
    Private _OffsetTheta As Double

    Public Sub New()

        Me._X = 0
        Me._Y = 0
        Me._Theta = 0

        Me.ResetOffsets(0, 0, 0)

    End Sub

    Public Sub Load(ByVal msg As System.Collections.Specialized.StringDictionary) Implements ISensorData.Load
        Dim parts() As String = Strings.Split(msg("Pose"), ",")
        Me._X = Double.Parse(parts(0))
        Me._Y = Double.Parse(parts(1))
        Me._Theta = Double.Parse(parts(2))
    End Sub

    Public Sub ResetOffsets(ByVal x As Double, ByVal y As Double, ByVal theta As Double)
        Me._OffsetX = x - Me._X
        Me._OffsetY = y - Me._Y
        Me._OffsetTheta = theta - Me._Theta
    End Sub

    Private _X As Double
    Public ReadOnly Property X() As Double
        Get
            Return _OffsetX + _X
        End Get
    End Property

    Private _Y As Double
    Public ReadOnly Property Y() As Double
        Get
            Return _OffsetY + _Y
        End Get
    End Property

    Private _Theta As Double
    Public ReadOnly Property Theta() As Double
        Get
            Return _OffsetTheta + _Theta
        End Get
    End Property

End Class
