'SEN {Time 45.14} {Type Sonar} {Name F1 Range 4.4690} {Name F2 Range 1.9387} 

<Serializable()> _
Public Class SonarData
	Implements ISensorData

    Private Const FRONTKEY As String = "F"
    Private Const REARKEY As String = "R"

	Public Sub New()
		Me._front = New Dictionary(Of Integer, Double)
		Me._rear = New Dictionary(Of Integer, Double)
	End Sub

    Public Sub Load(ByVal msg As System.Collections.Specialized.StringDictionary) Implements ISensorData.Load
        For Each key As String In msg.Keys
            If key.ToUpper.StartsWith(FRONTKEY) Then
                Me._front(CInt(key.Substring(FRONTKEY.Length))) = Double.Parse(msg(key))
            ElseIf key.ToUpper.StartsWith(REARKEY) Then
                Me._rear(CInt(key.Substring(REARKEY.Length))) = Double.Parse(msg(key))
            End If
        Next
    End Sub

	Private _front As Dictionary(Of Integer, Double)
	Public ReadOnly Property Front(ByVal index As Integer) As Double
		Get
			Return Me._front(index)
		End Get
	End Property
	Public ReadOnly Property FrontCount() As Integer
		Get
			Return _front.Count
		End Get
	End Property

	Private _rear As Dictionary(Of Integer, Double)
	Public ReadOnly Property Rear(ByVal index As Integer) As Double
		Get
			Return Me._front(index)
		End Get
	End Property
	Public ReadOnly Property RearCount() As Integer
		Get
			Return _rear.Count
		End Get
	End Property

End Class
