Public Enum LaserRangeDeviceType
    SickLMS
    Hokuyo
End Enum

Public Class LaserRangeSensor
    Inherits MultiStateSensor(Of LaserRangeData)

    Public Shared ReadOnly SENSORTYPE_RANGESCANNER As String = "RangeScanner"

    Public ReadOnly DeviceType As LaserRangeDeviceType
    Public ReadOnly MinRange As Single
    Public ReadOnly MaxRange As Single
    Public ReadOnly OffsetX As Single
    Public ReadOnly OffsetY As Single


    Public Sub New(ByVal name As String, ByVal deviceType As LaserRangeDeviceType, ByVal minRange As Single, ByVal maxRange As Single, ByVal offsetx As Single, ByVal offsety As Single)
        MyBase.New(SENSORTYPE_RANGESCANNER, name, 10)

        Me.DeviceType = deviceType
        Me.MinRange = minRange
        Me.MaxRange = maxRange
        Me.OffsetX = offsetx
        Me.OffsetY = offsety

    End Sub



    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.Sensor Then

            Dim data As New LaserRangeData(Me.MinRange, Me.MaxRange, Me.OffsetX, Me.OffsetY)
            data.Load(msg)
            Me.EnqueueData(data)

            Me.Agent.NotifySensorUpdate(Me)

        End If

    End Sub

End Class
