Public Class SonarSensor
	Inherits SingleStateSensor(Of SonarData)

    Public Shared ReadOnly SENSORTYPE_SONAR As String = "Sonar"

    Public Sub New()
        MyBase.New(New SonarData, SENSORTYPE_SONAR, Sensor.MATCH_ANYNAME)
    End Sub
    ' Typical reading P2AT robot:
    'SEN {Time 4015.8388} {Type Sonar} {Name F1 Range 1.9991} {Name F2 Range 5.0000} {Name F3 Range 4.8843} {Name F4 Range 0.9377} {Name F5 Range 2.3472} {Name F6 Range 2.1501} {Name F7 Range 0.7115} {Name F8 Range 0.6085} {Name R1 Range 0.4477} {Name R2 Range 0.9995} {Name R3 Range 0.9862} {Name R4 Range 2.5638} {Name R5 Range 2.0131} {Name R6 Range 1.8465} {Name R7 Range 1.9408} {Name R8 Range 3.4782}

    Protected Overrides Function ToKeyValuePair(ByVal part As String) As System.Collections.Generic.KeyValuePair(Of String, String)
        Dim parts() As String = Strings.Split(part, " ")
        If parts.Length >= 3 Then
            If parts(0).ToUpper = "NAME" Then
                Return New KeyValuePair(Of String, String)(parts(1), parts(3).Trim)
            End If
        End If

        Return MyBase.ToKeyValuePair(part)

    End Function

    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.Sensor Then
            Me.CurrentData.Load(msg)
            Me.Agent.NotifySensorUpdate(Me)
        End If

    End Sub

End Class
