<Serializable()> _
Public Class Matrix2
    Inherits Matrix

#Region " Basics "

    'copy constructor
    Public Sub New(ByVal source As Matrix)
        MyBase.New(source)
    End Sub

    Public Sub New()
        MyBase.New(2)
    End Sub

    Public Sub New(ByVal v00 As Double, ByVal v01 As Double, ByVal v10 As Double, ByVal v11 As Double)
        MyBase.New(2)
        Me(0, 0) = v00
        Me(0, 1) = v01
        Me(1, 0) = v10
        Me(1, 1) = v11
    End Sub

    Public Overloads Function Transpose() As Matrix2
        Return New Matrix2(MyBase.Transpose)
    End Function

    Public Overrides Function Determinant() As Double
        Return Me(0, 0) * Me(1, 1) - Me(0, 1) * Me(1, 0)
    End Function

    Public Function Invert() As Matrix2
        Dim answer As New Matrix2
        Dim det As Double = Me.Determinant
        answer(0, 0) = 1 / det * Me(1, 1)
        answer(0, 1) = 1 / det * -Me(0, 1)
        answer(1, 0) = 1 / det * -Me(1, 0)
        answer(1, 1) = 1 / det * Me(0, 0)
        Return answer
    End Function

#End Region

#Region " Operators "

    Public Overloads Shared Operator -(ByVal right As Matrix2) As Matrix2
        Return New Matrix2(right.Negative)
    End Operator

    Public Overloads Shared Operator +(ByVal left As Matrix2, ByVal right As Matrix2) As Matrix2
        Return New Matrix2(left.Add(right))
    End Operator
    Public Overloads Shared Operator -(ByVal left As Matrix2, ByVal right As Matrix2) As Matrix2
        Return New Matrix2(left.Subtract(right))
    End Operator

    Public Overloads Shared Operator *(ByVal factor As Double, ByVal matrix As Matrix2) As Matrix2
        Return New Matrix2(matrix.Multiply(factor))
    End Operator
    Public Overloads Shared Operator *(ByVal matrix As Matrix2, ByVal factor As Double) As Matrix2
        Return New Matrix2(matrix.Multiply(factor))
    End Operator
    Public Overloads Shared Operator *(ByVal left As Matrix2, ByVal right As Matrix2) As Matrix2
        Return New Matrix2(left.Multiply(right))
    End Operator
    Public Overloads Shared Operator *(ByVal matrix As Matrix2, ByVal vector As Vector2) As Vector2
        Return New Vector2(matrix.Multiply(vector))
    End Operator

#End Region

End Class


