<Serializable()> _
Public Class Matrix3
    Inherits Matrix

#Region " Basics "

    'copy constructor
    Public Sub New(ByVal source As Matrix)
        MyBase.New(source)
    End Sub

    Public Sub New()
        MyBase.New(3)
    End Sub

#End Region

#Region " Operators "

    Public Overloads Shared Operator -(ByVal right As Matrix3) As Matrix3
        Return New Matrix3(right.Negative)
    End Operator

    Public Overloads Shared Operator +(ByVal left As Matrix3, ByVal right As Matrix3) As Matrix3
        Return New Matrix3(left.Add(right))
    End Operator
    Public Overloads Shared Operator -(ByVal left As Matrix3, ByVal right As Matrix3) As Matrix3
        Return New Matrix3(left.Subtract(right))
    End Operator

    Public Overloads Shared Operator *(ByVal factor As Double, ByVal matrix As Matrix3) As Matrix3
        Return New Matrix3(matrix.Multiply(factor))
    End Operator
    Public Overloads Shared Operator *(ByVal matrix As Matrix3, ByVal factor As Double) As Matrix3
        Return New Matrix3(matrix.Multiply(factor))
    End Operator
    Public Overloads Shared Operator *(ByVal left As Matrix3, ByVal right As Matrix3) As Matrix3
        Return New Matrix3(left.Multiply(right))
    End Operator
    Public Overloads Shared Operator *(ByVal matrix As Matrix3, ByVal vector As Vector3) As Vector3
        Return New Vector3(matrix.Multiply(vector))
    End Operator

#End Region

End Class


