<Serializable()> _
Public Class Pose2D

#Region " Constructor and Properties "

    Private _Position As Vector2
    Private _Rotation As Double

    Public Sub New()
        Me.New(New Vector2(0, 0), 0)
    End Sub
    Public Sub New(ByVal rotation As Double)
        Me.New(New Vector2(0, 0), rotation)
    End Sub

    Public Sub New(ByVal x As Double, ByVal y As Double, ByVal rotation As Double)
        Me.New(New Vector2(x, y), rotation)
    End Sub

    Public Sub New(ByVal position As Vector2, ByVal rotation As Double)
        Me.Position = position
        Me.Rotation = rotation
    End Sub

    Public Property Position() As Vector2
        Get
            Return _Position
        End Get
        Set(ByVal value As Vector2)
            Me._Position = value
        End Set
    End Property

    Public Property X() As Double
        Get
            Return Me._Position.X
        End Get
        Set(ByVal value As Double)
            Me._Position.X = value
        End Set
    End Property

    Public Property Y() As Double
        Get
            Return Me._Position.Y
        End Get
        Set(ByVal value As Double)
            Me._Position.Y = value
        End Set
    End Property

    Public Property Rotation() As Double
        Get
            Return Me._Rotation
        End Get
        Set(ByVal value As Double)
            Me._Rotation = value
        End Set
    End Property

    Public Overrides Function ToString() As String
        Return Me.ToString(5, 5)
    End Function

    Public Overloads Function ToString(ByVal decimalsInPosition As Integer) As String
        Return String.Format(String.Format("{{0:f{0}}} , {{1:f{0}}}", decimalsInPosition), Me.X / 1000, Me.Y / 1000)
    End Function

    Public Overloads Function ToString(ByVal decimalsInPosition As Integer, ByVal decimalsInRotation As Integer) As String
        Return String.Format(String.Format("{{0:f{0}}} , {{1:f{0}}} / {{2:f{1}}}", decimalsInPosition, decimalsInRotation), Me.X / 1000, Me.Y / 1000, Me.Rotation)
    End Function

#End Region

#Region " Smart Functions "

    Public Function ToGlobalMatrix() As TMatrix2D
        Return New TMatrix2D(Me.Position, Me.Rotation)
    End Function

    Public Function ToLocalMatrix() As TMatrix2D
        Dim mx As New TMatrix2D(-Me.Rotation)
        Dim merotated As Pose2D = mx * Me
        mx.Translation = -merotated.Position
        Return mx
    End Function

    Public Function ToGlobal(ByVal currentOrigin As Pose2D) As Pose2D
        Dim rotmx As TMatrix2D = currentOrigin.ToGlobalMatrix
        Dim pglobal As Pose2D = rotmx * Me
        Return pglobal
    End Function

    Public Function ToLocal(ByVal targetOrigin As Pose2D) As Pose2D
        Dim rotmx As TMatrix2D = targetOrigin.ToLocalMatrix
        Dim plocal As Pose2D = rotmx * Me
        Return plocal
    End Function

#End Region

End Class

