#region MathNet Numerics, Copyright 2004 Joannes Vermorel

// MathNet Numerics, part of MathNet
//
// Copyright (c) 2004,	Joannes Vermorel, http://www.vermorel.com
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published 
// by the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#endregion

namespace MathNet.Numerics
{
	/// <summary>
	/// <p><c>MathNet.Numerics</c> aims to provide the mathematical tools
	/// commonly used for numeric scientific computation.</p>
	/// 
	/// <p>The current implementation contains
	/// <ul>
	///		<li>A linear algebra package, see 
	///		<see cref="MathNet.Numerics.LinearAlgebra"/>.</li>
	///		<li>A sparse linear algebra package, see
	///		<see cref="MathNet.Numerics.LinearAlgebra.Sparse"/>.</li>
	///		<li>Non-uniform random generators, see 
	///		<see cref="MathNet.Numerics.Generators"/>.</li>
	///		<li>Distribution fonctions, see
	///		<see cref="MathNet.Numerics.Distributions"/>.</li>
	///		<li>Statistics tools, see
	///		<see cref="MathNet.Numerics.Statistics"/>.</li>
	///		<li>Fourier transformation, see
	///		<see cref="MathNet.Numerics.Transformations"/>.</li>
	/// </ul>
	/// </p>
	/// 
	/// <p>Authors: Joannes Vermorel, Christoph Ruegg</p>
	/// </summary>
	public class NamespaceDoc
	{
		// nothing, for documentation only
	}
}
