Imports System.IO

Imports UvARescue.Agent
Imports UvARescue.Math
Imports UvARescue.Slam
Imports UvARescue.Usar.Lib
Imports UvARescue.Tools

Public Class MainForm

    Private image As ManifoldImage
    Private teamController As TeamController
    Private mapController As MapController

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)

        'set the tread's name (very convenient when debugging)
        Threading.Thread.CurrentThread.Name = "UI"

        'restore last form bounds
        With My.Settings
            Me.Left = .LastFormLeft
            Me.Top = .LastFormTop
            Me.Width = .LastFormWidth
            Me.Height = .LastFormHeight
        End With

        'setup UI
        Dim manifold As New Manifold
        Me.image = New ManifoldImage(manifold, 20)

        Me.mapController = New MapController(New ManifoldView(image))
        Me.mapController.Dock = DockStyle.Fill
        Me.pnlMap.Controls.Add(Me.mapController)
        Me.pnlMap.Controls.SetChildIndex(Me.mapController, 0)

        Me.teamController = New TeamController(manifold)
        teamController.Dock = DockStyle.Fill
        Me.pnlController.Controls.Add(Me.teamController)
        Me.pnlController.Controls.SetChildIndex(Me.teamController, 0)

    End Sub

    Protected Overrides Sub OnClosing(ByVal e As System.ComponentModel.CancelEventArgs)
        Dim quit As Boolean = Me.teamController.QueryCanQuitApplication
        If Not quit Then
            e.Cancel = True

        Else
            'save last form bounds
            With My.Settings
                If Not Me.WindowState = FormWindowState.Minimized Then
                    .LastFormLeft = Me.Left
                    .LastFormTop = Me.Top
                    .LastFormWidth = Me.Width
                    .LastFormHeight = Me.Height
                    .Save()
                End If
            End With
        End If
        MyBase.OnClosing(e)
    End Sub



    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

End Class
