Imports UvARescue.Agent
Imports UvARescue.Tools

Imports System.IO
Imports System.Windows.Forms

Public Class TeamConfigDialog
    Inherits ConfigDialog

    Public Sub New(ByVal config As TeamConfig)
        MyBase.New(config)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

    End Sub

    Public ReadOnly Property TeamConfig() As TeamConfig
        Get
            Return DirectCast(MyBase.Config, TeamConfig)
        End Get
    End Property

    Protected Overrides Sub OnOpened(ByVal filename As String)
        MyBase.OnOpened(filename)
        My.Settings.LastTeamConfigFile = filename
        My.Settings.Save()
    End Sub
    Protected Overrides Sub OnSaved(ByVal filename As String)
        MyBase.OnSaved(filename)
        My.Settings.LastTeamConfigFile = filename
        My.Settings.Save()
    End Sub

    Public Property OperatorName() As String
        Get
            Return Me.txtOperatorName.Text
        End Get
        Set(ByVal value As String)
            Me.txtOperatorName.Text = value
        End Set
    End Property

    Public Property TeamMembers() As String
        Get
            Return Me.txtTeamMembers.Text
        End Get
        Set(ByVal value As String)
            Me.txtTeamMembers.Text = value
        End Set
    End Property

    Protected Overrides Sub SyncGuiWithConfig()
        MyBase.SyncGuiWithConfig()
        With Me.TeamConfig

            Me.txtLocalhost.Text = .LocalHost
            Me.txtUsarSimHost.Text = .UsarSimHost
            Me.txtUsarSimPort.Text = CStr(.UsarSimPort)
            Me.txtImageServerHost.Text = .ImageServerHost
            Me.txtImageServerPort.Text = CStr(.ImageServerPort)
            Me.txtWirelessServerHost.Text = .WirelessServerHost
            Me.txtWirelessServerPort.Text = CStr(.WirelessServerPort)
        End With
    End Sub

    Protected Overrides Sub SyncConfigWithGui()
        MyBase.SyncConfigWithGui()
        With Me.TeamConfig

            .OperatorName = Me.txtOperatorName.Text
            .TeamMembers = Me.txtTeamMembers.Text

            .LocalHost = Me.txtLocalhost.Text

            .UsarSimHost = Me.txtUsarSimHost.Text
            If IsNumeric(Me.txtUsarSimPort.Text) Then
                .UsarSimPort = CInt(Double.Parse(Me.txtUsarSimPort.Text))
            End If

            .ImageServerHost = Me.txtImageServerHost.Text
            If IsNumeric(Me.txtImageServerPort.Text) Then
                .ImageServerPort = CInt(Double.Parse(Me.txtImageServerPort.Text))
            End If

            .WirelessServerHost = Me.txtWirelessServerHost.Text
            If IsNumeric(Me.txtWirelessServerPort.Text) Then
                .WirelessServerPort = CInt(Double.Parse(Me.txtWirelessServerPort.Text))
            End If
        End With
    End Sub

End Class
