Imports System.Drawing
Imports System.Windows.Forms

Imports UvARescue.Slam
Imports UvARescue.Tools

Public Class MapController

    Public Sub New(ByVal view As ManifoldView)
        MyBase.New()

        If IsNothing(view) Then Throw New ArgumentNullException("view")
        Me._ManifoldView = view

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        view.Dock = Windows.Forms.DockStyle.Fill
        Me.pnlManifold.Controls.Add(view)

    End Sub

    Private _ManifoldView As ManifoldView
    Public ReadOnly Property ManifoldView() As ManifoldView
        Get
            Return Me._ManifoldView
        End Get
    End Property

    Private Sub btnSaveMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveMap.Click
        Dim dlg As New SaveMapDialog(Me.ManifoldView.Image)
        Select Case dlg.ShowDialog
        End Select
    End Sub

    Private Sub btnLoadApriori_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadApriori.Click
        Dim dlg As New OpenFileDialog
        dlg.RestoreDirectory = True
        Select Case dlg.ShowDialog
            Case Windows.Forms.DialogResult.OK
                Me._ManifoldView.Image.AprioriFileName = dlg.FileName
                Me._ManifoldView.Invalidate()

        End Select
    End Sub

    Private Sub btnZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomIn.Click
        Me._ManifoldView.ZoomIn()
    End Sub

    Private Sub btnZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomOut.Click
        Me._ManifoldView.ZoomOut()
    End Sub

    Private Sub btnZoomAuto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomAuto.Click
        Me._ManifoldView.AutoZoom()
    End Sub

    Private Sub chkApriori_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkApriori.CheckedChanged
        Me._ManifoldView.ShowAprioriLayer = Me.chkApriori.Checked
        Me._ManifoldView.Invalidate()
    End Sub
    Private Sub chkAprioriMobility_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkAprioriMobility.CheckedChanged
        Me._ManifoldView.Image.ShowAprioriMobility = Me.chkAprioriMobility.Checked
        Me._ManifoldView.Invalidate()
    End Sub
    Private Sub chkAprioriVictims_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkAprioriVictims.CheckedChanged
        Me._ManifoldView.Image.ShowAprioriVictims = Me.chkAprioriVictims.Checked
        Me._ManifoldView.Invalidate()
    End Sub
    Private Sub chkAprioriComm_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkAprioriComm.CheckedChanged
        Me._ManifoldView.Image.ShowAprioriComm = Me.chkAprioriComm.Checked
        Me._ManifoldView.Invalidate()
    End Sub



    Private Sub chkFreeSpace_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkFreeSpace.CheckedChanged
        Me._ManifoldView.ShowFreeSpaceLayer = Me.chkFreeSpace.Checked
    End Sub
    Private Sub chkClearSpace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkClearSpace.Click
        Me._ManifoldView.ShowClearSpaceLayer = Me.chkClearSpace.Checked
    End Sub
    Private Sub chkObservations_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkObservations.CheckedChanged
        Me._ManifoldView.ShowObservationsLayer = Me.chkObservations.Checked
    End Sub
    Private Sub chkAgents_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkAgents.CheckedChanged
        Me._ManifoldView.ShowAgentsLayer = Me.chkAgents.Checked
    End Sub

End Class
